<?php

set_time_limit(60);
$printDebug = false;
$debug = array();

function setValue($data, $pos, $newVal, $mode){
  if($mode == 1){
    $data[ $pos ] = $newVal;
    // return $pos;
  }
  else {
    $data[ $data[$pos] ] = $newVal;
    // return $data[$pos];
  }
  return $data;
}
function getValue($data, $val, $mode){
  if($mode == 1){
    return $data[ $val ];
  }
  else {
    return $data[ $data[ $val ] ];
  }
}

// FROM day2.php:
function Intcode($input, $inputParam = "", $i = "", $j = ""){
  global $printDebug, $debug;
  $output = array();
  $input0 = explode(",", trim($input));
  $input1 = $input0;

  $batchPos = 0;
  $jumps = 0;
  $executions = 0;

  /*** OPCODE LOOP ***/
  while($batchPos < count($input1)){
    $executions++;
    if($executions > 1000){ 
      echo  "KILLED due to 1000 executions.";
      break; 
    }

    //INSTRUCTIOnS
    $instr = array_reverse( str_split( substr($input0[$batchPos],0,-2) ) );
    $mode1 = @$instr[0];
    $mode2 = @$instr[1];
    $mode3 = @$instr[2];

    if(substr($input1[$batchPos],-2) == 99){
      $debug[] = "Opcode 99: halts.";
      break;
    }
    elseif(substr($input1[$batchPos],-1) == 1){
      $debug[] = $batchPos.": ".$input1[$batchPos].",".$input1[$batchPos+1].", ".$input1[$batchPos+2].", ".$input1[$batchPos+3];
      
      $newVal = (getValue($input1, $batchPos+1, $mode1) + getValue($input1, $batchPos+2, $mode2));
      $input1 = setValue($input1, $batchPos+3, $newVal, $mode3);
      $debug[] = "Set new value to ".$newVal;

      $batchPos += 4;
    }
    elseif(substr($input1[$batchPos],-1) == 2){
      $debug[] = $batchPos.": ".$input1[$batchPos].", ".$input1[$batchPos+1].", ".$input1[$batchPos+2].", ".$input1[$batchPos+3];

      $newVal = (getValue($input1, $batchPos+1, $mode1) * getValue($input1, $batchPos+2, $mode2));
      $input1 = setValue($input1, $batchPos+3, $newVal, $mode3);
      $debug[] = "Set new value to ".$newVal;
      
      $batchPos += 4;
    }
    // ADDED for day 5
    elseif(substr($input1[$batchPos],-1) == 3){ // Requires some input.
      $debug[] = $batchPos.": ".$input1[$batchPos].", ".$input1[$batchPos+1];
      $input1[$input1[$batchPos+1]] = $inputParam;
      $debug[] = "Set value of ".$input1[$batchPos+1]." to: ".$inputParam;
      $batchPos += 2;
    }
    elseif(substr($input1[$batchPos],-1) == 4){
      $debug[] = $batchPos.": ".$input1[$batchPos].", ".$input1[$batchPos+1].", ".$input1[$batchPos+2];
      $output[] = "Opcode 4: ".$input1[ ($mode1 == 1?$batchPos+1:$input1[$batchPos+1]) ];
      $batchPos += 2;
    }
    // DAY 5, part 2:
    elseif(substr($input1[$batchPos],-1) == 5){ //jump-if-true
      $debug[] = $batchPos.": ".$input1[$batchPos].", ".$input1[$batchPos+1].", ".$input1[$batchPos+2];
      if(getValue($input1, $batchPos+1, $mode1) != 0){
      // if($input1[$batchPos+1] != 0 && $jumps < 10){
        // $batchPos = $input1[ ($mode2 == 1?$batchPos+2:$input1[$batchPos+2]) ];
        
        $newBatchPos = getValue($input1, $batchPos+2, $mode2);
        $debug[] = "Jumped to ".$newBatchPos." (first value: ".getValue($input1, $batchPos+1, $mode1).")";
        // $output[] = "Jumped to ".$newBatchPos;
        $batchPos = $newBatchPos;
      }
      else {
        $batchPos += 3;
      }
    }
    elseif(substr($input1[$batchPos],-1) == 6){ //jump-if-false
      $debug[] = $batchPos.": ".$input1[$batchPos].", ".$input1[$batchPos+1].", ".$input1[$batchPos+2];
      if(getValue($input1, $batchPos+1, $mode1) == 0){

        $newBatchPos = getValue($input1, $batchPos+2, $mode2);
        $debug[] = "Jumped to ".$newBatchPos." (first value: ".getValue($input1, $batchPos+1, $mode1).")";
        // $output[] = "Jumped to ".$newBatchPos;
        $batchPos = $newBatchPos;
      }
      else {
        $batchPos += 3;
      }
    }
    elseif(substr($input1[$batchPos],-1) == 7){ //less than
      $debug[] = $batchPos.": ".$input1[$batchPos].", ".$input1[$batchPos+1].", ".$input1[$batchPos+2].", ".$input1[$batchPos+3];
      if($input1[($mode1 == 1?$batchPos+1:$input1[$batchPos+1])] < $input1[($mode2 == 1?$batchPos+2:$input1[$batchPos+2])]){ 
        $input1[($mode3 == 1?$batchPos+3:$input1[$batchPos+3])] = 1; 
      }
      else { 
        $input1[($mode3 == 1?$batchPos+3:$input1[$batchPos+3])] = 0; 
      }
      $batchPos += 4;
    }
    elseif(substr($input1[$batchPos],-1) == 8){
      $debug[] = $batchPos.": ".$input1[$batchPos].", ".$input1[$batchPos+1].", ".$input1[$batchPos+2].", ".$input1[$batchPos+3];
      if($input1[($mode1 == 1?$batchPos+1:$input1[$batchPos+1])] == $input1[($mode2 == 1?$batchPos+2:$input1[$batchPos+2])]){
        $input1[($mode3 == 1?$batchPos+3:$input1[$batchPos+3])] = 1; 
      }
      else { 
        $input1[($mode3 == 1?$batchPos+3:$input1[$batchPos+3])] = 0;
      }
      $batchPos += 4;
    }
    else {
      $debug[] = $batchPos.": Unknown opcode: $input1[$batchPos]";
      $output[] = "Unknown opcode: $input1[$batchPos]";
      break;
      // $batchPos++;
    }
    // $batchPos += 4;
    // if($printDebug){ 
      // echo implode("<br>\n", $debug)."<br><br>\n"; 
      // $debug = array();
    // }
  }
  
  if(empty($output)){ $output[] = "No outputs. Here is first value: ".$input1[0]; }
  
  if($printDebug && !empty($debug)){ echo "<br><br>\nDebug: <br>".implode("<br>\n", $debug)."<br>\n"."<hr>"; }

  return implode("<br>\n", $output); 
  // else { return implode(",",$input1); }
  // return $input1[0];
  // if($i == 12 && $j == 2){ echo "Part 1 output: ".$input1[0]."\n"; }
  // if($input1[0] == 19690720){ echo "Part 2 output: ". (100 * $i + $j); break; }
  // if($i > 1){ break; }
}

$input = "2,3,0,3,99";
$input = "2,4,4,5,99,0";
$input = "1,1,1,4,99,5,6,0,99";
$input = "1002,4,3,4,33";
$input = "1101,100,-1,4,0";
$input = "3,9,8,9,10,9,4,9,99,-1,8";
// $input = "3,21,1008,21,8,20,1005,20,22,107,8,21,20,1006,20,31,1106,0,36,98,0,0,1002,21,125,20,4,20,1105,1,46,104,999,1105,1,46,1101,1000,1,20,4,20,1105,1,46,98,99";
// $input = "3,9,7,9,10,9,4,9,99,-1,8";
// $input = "3,3,1108,-1,8,3,4,3,99";
$input = file_get_contents("day5.txt");

// header("Content-Type: application/json");
// echo json_encode( explode(",",$input) );
// die();


/* * /
foreach( explode(",",$input) as $key => $value ){
  echo $value.",";
  if(!(($key+1) % 4) && $key > 1){ echo "<br>\n"; }
}
die();
/* */
// echo $input."<br>\n";
// echo Intcode($input, 5)."<br>\n";
// echo Intcode($input, 7)."<br>\n";
// echo Intcode($input, 8)."<br>\n";
echo Intcode($input, 5);
// echo "<script>console.log( JSON.parse('".json_encode( explode(",",$input) )."'));</script>";
?>